Index: contrib/cvs/src/login.c
===================================================================
RCS file: /home/ncvs/src/contrib/cvs/src/login.c,v
retrieving revision 1.8
diff -u -d -r1.8 login.c
--- contrib/cvs/src/login.c	15 Apr 2004 01:17:27 -0000	1.8
+++ contrib/cvs/src/login.c	19 Apr 2005 19:14:15 -0000
@@ -116,7 +116,7 @@
 
 	if (isspace(*(linebuf + 1)))
 	    /* special case since strtoul ignores leading white space */
-	    entry_version = 0;
+	    q = linebuf + 1;
 	else
 	    entry_version = strtoul (linebuf + 1, &q, 10);
 
Index: contrib/cvs/src/patch.c
===================================================================
RCS file: /home/ncvs/src/contrib/cvs/src/patch.c,v
retrieving revision 1.1.1.13
diff -u -d -r1.1.1.13 patch.c
--- contrib/cvs/src/patch.c	15 Apr 2004 01:01:55 -0000	1.1.1.13
+++ contrib/cvs/src/patch.c	19 Apr 2005 19:14:15 -0000
@@ -385,6 +385,7 @@
     struct utimbuf t;
     char *vers_tag, *vers_head;
     char *rcs = NULL;
+    char *rcs_orig = NULL;
     RCSNode *rcsfile;
     FILE *fp1, *fp2, *fp3;
     int ret = 0;
@@ -415,7 +416,7 @@
     if ((rcsfile->flags & VALID) && (rcsfile->flags & INATTIC))
 	isattic = 1;
 
-    rcs = xmalloc (strlen (finfo->file) + sizeof (RCSEXT) + 5);
+    rcs_orig = rcs = xmalloc (strlen (finfo->file) + sizeof (RCSEXT) + 5);
     (void) sprintf (rcs, "%s%s", finfo->file, RCSEXT);
 
     /* if vers_head is NULL, may have been removed from the release */
@@ -757,8 +758,8 @@
 	free (vers_tag);
     if (vers_head != NULL)
 	free (vers_head);
-    if (rcs != NULL)
-	free (rcs);
+    if (rcs_orig)
+	free (rcs_orig);
     return ret;
 }
 
Index: contrib/cvs/src/rcs.c
===================================================================
RCS file: /home/ncvs/src/contrib/cvs/src/rcs.c,v
retrieving revision 1.27
diff -u -d -r1.27 rcs.c
--- contrib/cvs/src/rcs.c	6 Jul 2004 08:10:38 -0000	1.27
+++ contrib/cvs/src/rcs.c	19 Apr 2005 19:14:15 -0000
@@ -3041,8 +3041,7 @@
     if (retval != NULL)
 	return (retval);
 
-    if (!force_tag_match ||
-	(vers != NULL && RCS_datecmp (vers->date, date) <= 0))
+    if (vers && (!force_tag_match || RCS_datecmp (vers->date, date) <= 0))
 	return xstrdup (vers->version);
     else
 	return NULL;
@@ -4139,7 +4138,7 @@
     size_t len;
     int free_value = 0;
     char *log = NULL;
-    size_t loglen;
+    size_t loglen = 0;
     Node *vp = NULL;
 #ifdef PRESERVE_PERMISSIONS_SUPPORT
     uid_t rcs_owner = (uid_t) -1;
@@ -7457,7 +7456,7 @@
 
 		for (ln = 0; ln < headlines.nlines; ++ln)
 		{
-		    char buf[80];
+		    char *buf;
 		    /* Period which separates year from month in date.  */
 		    char *ym;
 		    /* Period which separates month from day in date.  */
@@ -7468,10 +7467,12 @@
 		    if (prvers == NULL)
 			prvers = vers;
 
+		    buf = xmalloc (strlen (prvers->version) + 24);
 		    sprintf (buf, "%-12s (%-8.8s ",
 			     prvers->version,
 			     prvers->author);
 		    cvs_output (buf, 0);
+		    free (buf);
 
 		    /* Now output the date.  */
 		    ym = strchr (prvers->date, '.');
